#include <avr/io.h>
#include <avr/interrupt.h>

#include <util/delay.h>

#include <stdlib.h>
#include <stdio.h>

volatile int cycle = 0;

volatile int motor1 = 0;
volatile int motor2 = 0;

volatile int modOperare = 0;
volatile int lovit = 0;

ISR(TIMER1_COMPA_vect)
{
    cycle += 1;
    cycle = cycle % 20;


    if (modOperare == 0) {
	    if (((1 << PA0) & PINA) == 0) {    	
	    	motor1 = 1;
	    }
	    else if (((1 << PA1) & PINA) == 0) {
	    	motor1 = -1;
	    }
	    else {
	    	motor1 = 0;
	    }

	    if (((1 << PC6) & PINC) == 0) {    	
	    	motor2 = 1;
	    }
	    else if (((1 << PC5) & PINC) == 0) {
	    	motor2 = -1;
	    }
	    else {
	    	motor2 = 0;
	    }
	}

    if (cycle == 0) {
    	if (motor1 == 1 || motor1 == -1)
    		PORTB |= (1 << PB7);
    	if (motor2 == 1 || motor2 == -1)
    		PORTD |= (1 << PD7);
    }
    	
    else if (cycle == 1) {
    	if (motor1 == -1)
    		PORTB |= (1 << PB7);
    	else PORTB &= ~(1 << PB7);
    	if (motor2 == -1)
    		PORTD |= (1 << PD7);
    	else PORTD &= ~(1 << PD7);
    }
    else {
    	PORTB &= ~(1 << PB7);
    	PORTD &= ~(1 << PD7);
    }
}

int main(void) {
	DDRD |= (1 << PD5 | 1 << PD7);
	DDRB |= (1 << PB7);
	DDRA &= ~(1 << PA0);
	DDRA &= ~(1 << PA1);
	DDRA &= ~(1 << PA2);
	DDRA &= ~(1 << PA3);
	DDRC &= ~(1 << PC5);
	DDRC &= ~(1 << PC6);

	PORTA |= (1 << PA0) | (1 << PA1) | (1 << PA2) | (1 << PA3);
	PORTC |= (1 << PC5) | (1 << PC6);

	sei();

    TCCR1B |= (1 << CS12);
    TCCR1B |= (1 << CS10);
    TIMSK1 |= (1 << OCIE1A) | (1 << TOIE1);


    TCCR1B |= (1 << WGM12);

    OCR1A =  15625 / 1000;


	while(1) {
		if ((PINA & (1 << PA2)) == 0) {
			modOperare = 1 - modOperare;
			motor1 = 0;
			motor2 = 0;
			_delay_ms(500);
		}
		if (modOperare == 1) {
			if ((PINA & (1 << PA3)) == 0 && lovit == 0) {
				motor2 = 1;
				// lovit = 1;
				_delay_ms(20);
			}
			else { 
				motor2 = -1;
				// lovit = 0;
				_delay_ms(100);
			}
		}
	}
 
	return 0;
}
